/// Provides default [Comparator] constructors, and various static extension
/// methods to modify and perform common operations on [Comparator] functions.
library comparator;

export 'src/comparator/compare_operators.dart';
export 'src/comparator/constructors/explicit.dart';
export 'src/comparator/constructors/natural.dart';
export 'src/comparator/constructors/reverse.dart';
export 'src/comparator/modifiers/compound.dart';
export 'src/comparator/modifiers/lexicographical.dart';
export 'src/comparator/modifiers/nulls_first.dart';
export 'src/comparator/modifiers/nulls_last.dart';
export 'src/comparator/modifiers/result_of.dart';
export 'src/comparator/modifiers/reversed.dart';
export 'src/comparator/operations/binary_search.dart';
export 'src/comparator/operations/largest.dart';
export 'src/comparator/operations/max.dart';
export 'src/comparator/operations/min.dart';
export 'src/comparator/operations/ordered.dart';
export 'src/comparator/operations/predicates.dart';
export 'src/comparator/operations/smallest.dart';
export 'src/comparator/operations/sort.dart';
